;#######################################################################
;#######################################################################
;#######################################################################
;																		
; 	rcall FUNKTION_TEMP1_9_CLEAR ; OUT: TEMP1...9 (alle 0)				
;																		
FUNKTION_TEMP1_9_CLEAR:
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	clr temp5
	clr temp6
	clr temp7
	clr temp8
	clr temp9
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
;																			
;	rcall FUNKTION_HEX_ASC_CLEAR_32  ; OUT TEMP1...9 (alle auf "0")			
;																			
FUNKTION_HEX_ASC_CLEAR_32:
	ldi temp1,'0'
	ldi temp2,'0'
	ldi temp3,'0'
	ldi temp4,'0'
	ldi temp5,'0'
	ldi temp6,'0'
	ldi temp7,'0'
	ldi temp8,'0'
	ldi temp9,'0'
ret
;###################################################################
;###################################################################
;###################################################################
;																	
;  rcall FUNKTION_BETRAG_BILDEN_32 	; INP:TEMP1...4 OUT: TEMP1...4  
;																	
FUNKTION_BETRAG_BILDEN_32:
	tst temp4
	brpl FUNKTION_BETRAG_BILDEN_32_w	; positiv ==> SPRUNG	
	com temp1			; invertieren
	com temp2
	com temp3
	com temp4
	ldi temp5,1
	clr temp6
	add temp1,temp5		; +1
	adc temp2,temp6
	adc temp3,temp6
	adc temp4,temp6
FUNKTION_BETRAG_BILDEN_32_w:
ret
;#######################################################################
;#######################################################################
;#######################################################################
; rcall FUNKTION_DIVISION_DURCH_10_32 ; INP: TEMP1...4 OUT: TEMP1...4 
FUNKTION_DIVISION_DURCH_10_32:
	ldi temp5,BYTE1(10)
	ldi temp6,BYTE2(10)
	ldi temp7,BYTE3(10)
	ldi temp8,BYTE4(10)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4		
ret
;#######################################################################
;#######################################################################
;#######################################################################
; rcall FUNKTION_DIVISION_DURCH_100_32 ; INP: TEMP1...4 OUT: TEMP1...4 
FUNKTION_DIVISION_DURCH_100_32:
	ldi temp5,BYTE1(100)
	ldi temp6,BYTE2(100)
	ldi temp7,BYTE3(100)
	ldi temp8,BYTE4(100)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4		
ret
;#######################################################################
;#######################################################################
;#######################################################################
; rcall FUNKTION_DIVISION_DURCH_1000_32 ; INP: TEMP1...4 OUT: TEMP1...4 
FUNKTION_DIVISION_DURCH_1000_32:
	ldi temp5,BYTE1(1000)
	ldi temp6,BYTE2(1000)
	ldi temp7,BYTE3(1000)
	ldi temp8,BYTE4(1000)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4		
ret
;#######################################################################
;#######################################################################
;#######################################################################
;																		
;		INPUT 	temp1  (LOW)											
;		INPUT 	temp2  													
;		INPUT 	temp3  													
;		INPUT 	temp4  (HIGH)											
;					 													
;		OUTPUT 	temp1 (LOW) 											
;		OUTPUT 	temp2 (HIGH)											
;																		
;		Hilfsregister: R0,R1,R14,R15,R16,R21,R22,R23,R24				
;																		
; 	rcall WURZEL_32		; INP: TEMP1...4 OUT: TEMP1...2					
;																		
WURZEL_32:
; HILFSREGISTER sichern	(STACK)						
	push R0
	push R1
	push R14
	push R15
	push R16
	push R21
	push R22
	push R23
	push R24
; HILFSREGISTER initialisieren 						
	ldi temp, 1
	mov R14, temp		;= 1						
	ldi temp, 2
	mov R15, temp		;= 2						
	clr   temp
	clr   r0          	; ERGEBNIS					
    clr   r1 
    ldi   r21,1        	;= 1						
    clr   r22 
    clr   r23 
    clr   r24 

; Wurzel-Berechnung									
WURZEL_32_w:
	sub   temp1,R21 	; SUBTRAKTION 				
    sbc   temp2,R22 
    sbc   temp3,R23 
    sbc   temp4,R24 
    brlo  WURZEL_32_ww
    add   R0,R14 		; ADDITION +1(Ergebnis)		
    adc   R1,temp 
    add   R21,R15 		; ADDITION +2			 	
    adc   R22,temp 
    adc   R23,temp 
    adc   R24,temp 
    rjmp  WURZEL_32_w
WURZEL_32_ww:   
	mov temp1,r0 		; ERGEBNIS KOPIEREN			
    mov temp2,r1 
; HILFSREGISTER wieder herstellen (STACK) 			
	pop R24
	pop R23
	pop R22
	pop R21
	pop R16
	pop R15
	pop R14
	pop R1
	pop R0
ret
;###############################################################################
;###############################################################################
;###############################################################################
; 																		 		
; FUNKTION DIVISION 32-32-BYTE													
; 																		 		
; 	INPUT: 	TEMP1....TEMP4 (0....4.294.967.295)	Divident				 		
;			TEMP5....TEMP8 (1....4.294.967.295)	Divisor 				 		
;																		 		
; 	OUTPUT;	TEMP1....TEMP5 (0....4.294.967.295) Quotient				 		
;																		 		
;	Hilfsregister: R0,R1,R2,R3,R4,R5,R6;R7,TEMP									
;																		 		
; rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
;																		 		
DIVISION_32_32:
; Register sichern	
	push R0
	push R1
	push R2
	push R3
	push R4
	push R5
	push R6
	push R7
; Register lschen	
	ldi temp,1
	mov	R0,temp				; HILFSREGISTER =1 
	clr R1
	clr R2
	clr R3

	clr R4					; ERGEBNIS			
	clr R5
	clr R6
	clr R7

; Divisor linksbndig 	
DIVISION_32_32_LINKS:
	tst	temp8					; Linksbndig ?		
	brmi DIVISION_32_32_START	; ja ==> SPRUNG		

	LSL R0						; HILFSREGISTER 1x links	
	ROL R1
	ROL R2
	ROL R3

	LSL	temp5					; DIVISOR 1x links	
	ROL temp6
	ROL temp7
	ROL temp8
	rjmp DIVISION_32_32_LINKS

; DIVISION START		
DIVISION_32_32_START:
	cp	temp4,temp8	; DIVIDENT ">=" DIVISOR	?	(H_H)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__w
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__w:
	cp	temp3,temp7	; DIVIDENT ">=" DIVISOR	?	(H_L)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__ww
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__ww:
	cp	temp2,temp6	; DIVIDENT ">=" DIVISOR	?	(L_H)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__www
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__www:
	cp	temp1,temp5	; DIVIDENT ">=" DIVISOR	?	(L_L)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG				

; ADDIEREN und SUBTRAHIEREN
DIVISION_32_32_ADD_SUB:
	add	R4,R0				; ERGEBNIS vergrern 				
	adc R5,R1
	adc R6,R2
	adc R7,R3

	sub	temp1,temp5			; DIVIDENT verkleinern				
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8

; 1 x rechts schieben		
DIVISION_32_32_SCHIEBEN:
	LSR	temp8				; DIVISOR 1 x rechts				
	ROR temp7
	ROR temp6
	ROR temp5

	LSR	R3					; HILFSREGISTER => 1 x rechts		
	ROR R2
	ROR R1
	ROR R0

; HILFSREGISTER=0 ?						
	TST R3						; =0 ?							
	brne DIVISION_32_32_START	; nein ==> SPRUNG				
	TST R2
	brne DIVISION_32_32_START			
	TST R1
	brne DIVISION_32_32_START	
	TST R0
	brne DIVISION_32_32_START	
; ERGEBNIS nach temp1...Temp4 kopieren	
	mov temp1, R4
	mov temp2, R5
	mov temp3, R6
	mov temp4, R7
; DIVISOR lschen						
	clr temp5
	clr temp6
	clr temp7
	clr temp8
; REGISTER wiederherstellen				
	pop R7
	pop R6
	pop R5
	pop R4
	pop R3
	pop R2
	pop R1
	pop R0
ret
;#######################################################################################
;#######################################################################################
;#######################################################################################
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor 	(0...65.535 (FF-FF) 							
;			TEMP3 / TEMP4	2.Faktor	(0...65.535 (FF-FF)  							
; 																						
; 	OUTPUT: 	TEMP1...4		Produkt		(4.294.836.225 (FF-FE-00-01)				
; 																						
;	HILFSREGISTER: R0,R1,R2,R3															
; 																						
; rcall FUNKTION_MULTIPLIKATION_16_16	; INP: TEMP1...2 / TEMP3...4 OUT: TEMP1...4 	
;																						
FUNKTION_MULTIPLIKATION_16_16:
; Hilfsregister sichern	(STACK)		
	push temp5
	push temp6
	push R0
	push R1
	push R2
	push R3
; Hilfsregister lschen				
	clr temp5
	clr temp6
	clr R0
	clr R1
	clr R2
	clr R3
; SCHLEIFE							
MUL_16_16_w:
	LSR temp4			; 2.Faktor 1x rechts 		
	ROR temp3
	BRCC MUL_16_16_ww	; kein C rollt heraus 		
	add R0, temp1		; 1. FAKOR addieren			
	adc R1, temp2
	adc R2, temp5
	adc R3, temp6
MUL_16_16_ww:	 
	LSL temp1			; 1. FAKOR 1x links			
	ROL temp2
	ROL temp5
	ROL temp6

	TST temp3			; 2.Faktor = NULL (LOW) ?	
	brne MUL_16_16_w
	TST temp4			; 2.Faktor = NULL (HIGH)?	
	brne MUL_16_16_w

	mov temp1, R0		; ERGEBNIS KOPIEREN 		
	mov temp2, R1
	mov temp3, R2
	mov temp4, R3

; REGISTER wieder herstellen (STACK)	
	pop R3
	pop R2
	pop R1
	pop R0
	pop temp6
	pop temp5
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
; 	INPUT: 	TEMP1 (Nummer des Datenfeldes)									
;																			
;	OUTPUT:	XL+XH (POSITION des DATENFELDES im SRAM)						
;																			
;	rcall FUNKTION_GPS_DATENFELD_SUCHEN ; INP: TEMP1(NR Datenfeld) OUT:XL+XH (POSITION im SRAM)
;																			
FUNKTION_GPS_DATENFELD_SUCHEN:
; HILFS-REGISTER								
	clr temp2
; X-ZEIGER-INITIALISIEREN						
	ldi XL, low(adr_GPS_DATEN_BEREICH_BEGINN)
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN)

FUNKTION_GPS_DATENFELD_START:
	; Fehlerprfung		
	cpi XH,high(adr_GPS_DATEN_BEREICH_ENDE)		; vergleich?
	brlo FUNKTION_GPS_DATENFELD_SUCHE			; kleiner	
	breq FUNKTION_GPS_DATENFELD_START_w			; gleich	
	brsh FUNKTION_GPS_DATENFELD_START_FEHLER	; grer	
FUNKTION_GPS_DATENFELD_START_w:
	cpi XL, low(adr_GPS_DATEN_BEREICH_ENDE)		; vergleich?
	brlo FUNKTION_GPS_DATENFELD_SUCHE			; kleiner	
	breq FUNKTION_GPS_DATENFELD_SUCHE			; gleich	
	brsh FUNKTION_GPS_DATENFELD_START_FEHLER	; grer	
	; FEHLER => DATENFELD nicht gefunden	
FUNKTION_GPS_DATENFELD_START_FEHLER:
	ldi XL, low(adr_GPS_DATEN_BEREICH_BEGINN)
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN)
	ret
FUNKTION_GPS_DATENFELD_SUCHE:
	; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp,X+
	cpi temp, ','								; vergleich ","					
	breq FUNKTION_GPS_DATENFELD_SUCHE_w			; ist gleich					
	cpi temp, '*'								; vergleich "*"					
	breq FUNKTION_GPS_DATENFELD_SUCHE_w			; ist gleich					
	cpi temp, '$'								; vergleich "$"					
	breq FUNKTION_GPS_DATENFELD_SUCHE_w			; ist gleich					
	rjmp FUNKTION_GPS_DATENFELD_START			; ===> SCHLEIFE 				
FUNKTION_GPS_DATENFELD_SUCHE_w:
	inc temp2									; +1		
	cp temp1,temp2								; vergleich	
	breq FUNKTION_GPS_DATENFELD_SUCHE_ww		; ist gleich
	rjmp FUNKTION_GPS_DATENFELD_START			; ===> SCHLEIFE 					
FUNKTION_GPS_DATENFELD_SUCHE_ww:

ret
;###################################################################################################
;###################################################################################################
;###################################################################################################
; Ein Datenfeld (9Zeichen)komplett einlesen und bereinigen											
; Bsp: 	"123.45,100.23" => "12345"																	
;																									
;	INPUT: XL+XH (ZEIGERPOSITION-SRAM)		; OUTPUT:temp1...temp9  								
;																									
;	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 ; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp9  	
;																									
FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32:
	rcall FUNKTION_HEX_ASC_CLEAR_32 ; OUT TEMP1...9 (alle auf "0")			
	LD temp9,X+						; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp8,X+						; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp7,X+						; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp6,X+						; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp5,X+						; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp4,X+						; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp3,X+						; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp2,X+						; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+						; ZEICHEN einlesen und X-Zeiger erhhen							

; 1. SCHRITT DATENFELD rechtsbndig (nach Kommatas suchen)
; solange schieben, bis kein Komma mehr vorhanden		
GPS_DATENFELD_BEREINIGEN_1:
	cpi temp1, ','								; vergleich				
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN	; ist gleich ==> SPRUNG	
	cpi temp2, ','
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN
	cpi temp3, ','
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN
	cpi temp4, ','
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN
	cpi temp5, ','
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN
	cpi temp6, ','
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN
	cpi temp7, ','
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN
	cpi temp8, ','
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN
	cpi temp9, ','
	breq GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN
	rjmp GPS_DATENFELD_BEREINIGEN_1_FERTIG		; kein "," gefunden		
; --------------------------------------------
GPS_DATENFELD_BEREINIGEN_1_SCHIEBEN:
	mov temp1, temp2
	mov temp2, temp3
	mov temp3, temp4
	mov temp4, temp5
	mov temp5, temp6
	mov temp6, temp7
	mov temp7, temp8
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen			
	rjmp GPS_DATENFELD_BEREINIGEN_1				; SPRUNG=>erneute Prfung	
GPS_DATENFELD_BEREINIGEN_1_FERTIG:
; 2. SCHRITT DATENFELD nach Punkten suchen "."
GPS_DATENFELD_BEREINIGEN_2_1:
	cpi temp1, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_2			; kein "." gefunden		
	mov temp1, temp2							; 1 x SCHIEBEN			
	mov temp2, temp3
	mov temp3, temp4
	mov temp4, temp5
	mov temp5, temp6
	mov temp6, temp7
	mov temp7, temp8
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_2:
	cpi temp2, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_3			; kein "." gefunden		
	mov temp2, temp3
	mov temp3, temp4
	mov temp4, temp5
	mov temp5, temp6
	mov temp6, temp7
	mov temp7, temp8
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_3:
	cpi temp3, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_4			; kein "." gefunden		
	mov temp3, temp4
	mov temp4, temp5
	mov temp5, temp6
	mov temp6, temp7
	mov temp7, temp8
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_4:
	cpi temp4, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_5			; kein "." gefunden		
	mov temp4, temp5
	mov temp5, temp6
	mov temp6, temp7
	mov temp7, temp8
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_5:
	cpi temp5, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_6			; kein "." gefunden		
	mov temp5, temp6
	mov temp6, temp7
	mov temp7, temp8
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_6:
	cpi temp6, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_7			; kein "." gefunden		
	mov temp6, temp7
	mov temp7, temp8
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_7:
	cpi temp7, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_8			; kein "." gefunden		
	mov temp7, temp8
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_8:
	cpi temp8, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_9			; kein "." gefunden		
	mov temp8, temp9
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_9:
	cpi temp9, '.'								; vergleich				
	brne GPS_DATENFELD_BEREINIGEN_2_FERTIG		; kein "." gefunden		
	ldi temp9, '0'								; mit "0" auffllen		
GPS_DATENFELD_BEREINIGEN_2_FERTIG:
;----------------------------------------------------
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4								
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
;																			
; INPUT temp1	(          1-er)											
; INPUT temp2	(         10-er)											
; INPUT temp3	(        100-er)											
; INPUT temp4	(       1000-er)											
; INPUT temp5	(     10.000-er)											
; INPUT temp6	(    100.000-er)											
; INPUT temp7	(  1.000.000-er)											
; INPUT temp8	( 10.000.000-er)											
; INPUT temp9	(100.000.000-er)											
;																			
; OUTPUT temp1	(low)														
; OUTPUT temp2																
; OUTPUT temp3																
; OUTPUT temp4																
;																			
; VALUE: 0.....999.999.999  (3B-9A-C9-FF)									
;																			
; rcall FUNKTION_ASC_HEX_32 ; INP: TEMP1...9 / OUT: TEMP1...4				
;																			
FUNKTION_ASC_HEX_32:
; HILFSREGISTER sichern		
	push r1
	push r2
	push r3
	push r4
	push r5
	push r6
	push r7
	push r8
	push r9
; UMWANDLUNG in HEX			
	subi temp1, 48
	subi temp2, 48
	subi temp3, 48
	subi temp4, 48
	subi temp5, 48
	subi temp6, 48
	subi temp7, 48
	subi temp8, 48
	subi temp9, 48
	
; auf dem STACK ablegen (sichern)
	push temp9
	push temp8
	push temp7
	push temp6
	push temp5
	push temp4
	push temp3
	push temp2
	push temp1
; alle Register lschen									
	clr r1
	clr r2
	clr r3
	clr r4
	clr r5
	clr r6
	clr r7
	clr r8
	clr r9
	clr temp
	rcall FUNKTION_TEMP1_9_CLEAR ; OUT: TEMP1...9 (alle 0)				


; Wertigkeit-1 1-er								
	ldi temp,1
	mov r1,temp
	pop temp				; temp1 vom Stapel		
ZIFFER_1_P:
	cpi temp,0				; =0?					
	breq ZIFFER_1_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_1_P			; Zurck zur Prfung	
ZIFFER_1_fertig:
; Wertigkeit-2 10-er								
	ldi temp,low(10)
	mov r1,temp
	pop temp				; temp2 vom Stapel		
ZIFFER_2_P:
	cpi temp,0				; =0?					
	breq ZIFFER_2_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_2_P			; Zurck zur Prfung	
ZIFFER_2_fertig:
; Wertigkeit-3 100-er								
	ldi temp,low(100)
	mov r1,temp
	pop temp				; temp3 vom Stapel		
ZIFFER_3_P:
	cpi temp,0				; =0?					
	breq ZIFFER_3_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_3_P			; Zurck zur Prfung	
ZIFFER_3_fertig:
; Wertigkeit-4 1.000-er								
	ldi temp,LOW(1000)
	mov r1,temp
	ldi temp,BYTE2(1000)
	mov r2,temp
	pop temp				; temp4 vom Stapel		
ZIFFER_4_P:
	cpi temp,0				; =0?					
	breq ZIFFER_4_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_4_P			; Zurck zur Prfung	
ZIFFER_4_fertig:
; Wertigkeit-5 10.000-er								
	ldi temp,LOW(10000)
	mov r1,temp
	ldi temp,BYTE2(10000)
	mov r2,temp
	ldi temp,BYTE3(10000)
	mov r3,temp
	pop temp				; temp5 vom Stapel		
ZIFFER_5_P:
	cpi temp,0				; =0?					
	breq ZIFFER_5_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_5_P			; Zurck zur Prfung	
ZIFFER_5_fertig:
; Wertigkeit-6 100.000-er								
	ldi temp,LOW(100000)
	mov r1,temp
	ldi temp,BYTE2(100000)
	mov r2,temp
	ldi temp,BYTE3(100000)
	mov r3,temp
	pop temp				; temp6 vom Stapel		
ZIFFER_6_P:
	cpi temp,0				; =0?					
	breq ZIFFER_6_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_6_P			; Zurck zur Prfung	
ZIFFER_6_fertig:
; Wertigkeit-7  1.000.000-er								
	ldi temp,LOW(1000000)
	mov r1,temp
	ldi temp,BYTE2(1000000)
	mov r2,temp
	ldi temp,BYTE3(1000000)
	mov r3,temp
	pop temp				; temp7 vom Stapel		
ZIFFER_7_P:
	cpi temp,0				; =0?					
	breq ZIFFER_7_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_7_P			; Zurck zur Prfung	
ZIFFER_7_fertig:
; Wertigkeit-8  10.000.000-er								
	ldi temp,LOW(10000000)
	mov r1,temp
	ldi temp,BYTE2(10000000)
	mov r2,temp
	ldi temp,BYTE3(10000000)
	mov r3,temp
	ldi temp,BYTE4(10000000)
	mov r4,temp
	pop temp				; temp8 vom Stapel		
ZIFFER_8_P:
	cpi temp,0				; =0?					
	breq ZIFFER_8_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_8_P			; Zurck zur Prfung	
ZIFFER_8_fertig:
; Wertigkeit-9  100.000.000-er								
	ldi temp,LOW(100000000)
	mov r1,temp
	ldi temp,BYTE2(100000000)
	mov r2,temp
	ldi temp,BYTE3(100000000)
	mov r3,temp
	ldi temp,BYTE4(100000000)
	mov r4,temp
	pop temp				; temp9 vom Stapel		
ZIFFER_9_P:
	cpi temp,0				; =0?					
	breq ZIFFER_9_fertig	; ja					
	rcall ZIFFER_ZAEHLER	; Unterprogramm Zhler	
	rjmp ZIFFER_9_P			; Zurck zur Prfung	
ZIFFER_9_fertig:
; R1 bis R9 wieder herstellen (vom Stack)				
	pop r9
	pop r8
	pop r7
	pop r6
	pop r5
	pop r4
	pop r3
	pop r2
	pop r1
ret
;-------------------------------------------------------
ZIFFER_ZAEHLER:
	dec temp
	add	temp1, r1
	adc temp2, r2
	adc temp3, r3
	adc temp4, r4
	adc temp5, r5
	adc temp6, r6
	adc temp7, r7
	adc temp8, r8
	adc temp9, r9
ret
;######################################################################## 
;########################################################################
;######################################################################## 
;Pause nach jeder bertragung;50us Pause
wait50us:                              
           	ldi  temp, 255
wait50us_: 
			dec  temp
           	brne wait50us_
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
;Lngere Pause fr manche Befehle;5ms Pause
wait5ms:                               
	push temp1           ; temp1 auf dem Stack sichern            
	push temp2           ; temp2 auf dem Stack sichern            
;------------
        ldi temp1,110
	   	clr temp2

wait5ms_:
   		wdr				; WATCH-DOG	
		dec  temp2
        brne wait5ms_
        dec  temp1
        brne wait5ms_
;------------
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; bei 16 MHz Takt ca.100ms Pause													
WAIT_100ms:
	push temp1           ; temp1 auf dem Stack sichern            
	push temp2           ; temp2 auf dem Stack sichern            
	push temp3           ; temp3 auf dem Stack sichern            

;------------
	ldi	temp3,6
	clr temp2
	clr	temp1			
wait_100ms_w:	
	wdr					; WATCH-DOG	
	dec	temp1
	brne	wait_100ms_w
	dec	temp2		
	brne	wait_100ms_w
	dec	temp3		
	brne	wait_100ms_w

;------------
	pop temp3      		; temp3 wiederherstellen                    
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz Takt ca.1s Pause													
WAIT_1s:
	push temp1           ; temp1 auf dem Stack sichern            
	push temp2           ; temp2 auf dem Stack sichern            
	push temp3           ; temp3 auf dem Stack sichern            

;------------
	ldi	temp3,100			
	clr temp2
	clr	temp1			
wait1s_w:	
	wdr					; WATCH-DOG	
	dec	temp1
	brne	wait1s_w
	dec	temp2		
	brne	wait1s_w
	dec	temp3
	brne	wait1s_w
;------------
	pop temp3      		; temp3 wiederherstellen                    
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret