;#######################################################################
;#######################################################################
;#######################################################################
GPS_CLEAR_START:
; SRAM GPS_DATEN_BEREICH lschen								
	ldi XL, LOW (adr_GPS_DATEN_BEREICH_BEGINN)
	ldi XH, HIGH(adr_GPS_DATEN_BEREICH_BEGINN)
	clr temp	
GPS_CLEAR_START_w:
	ST X+,temp
	cpi XH, HIGH(adr_GPS_DATEN_BEREICH_ENDE)	; Vergleich?		
	brlo GPS_CLEAR_START_w						; kleiner => SPRUNG	
	cpi XL, LOW(adr_GPS_DATEN_BEREICH_ENDE)		; Vergleich?		
	brlo GPS_CLEAR_START_w						; kleiner => SPRUNG	
	breq GPS_CLEAR_START_w						; gleich  => SPRUNG	



; ANZAHL DATENSATZ lschen				
	clr temp
	STS(adr_GPS_DATEN_DATENSATZ_ANZAHL),temp
; ANZAHL ZEICHEN lschen				
	clr temp
	STS(adr_GPS_DATEN_ZEICHEN_ANZAHL_L),temp	; in SRAM schreiben	
	STS(adr_GPS_DATEN_ZEICHEN_ANZAHL_H),temp	; in SRAM schreiben	
; SCHREIB-POSITION auf ANFANG setzen	
	ldi temp1, low(adr_GPS_DATEN_BEREICH_BEGINN)
	ldi temp2,high(adr_GPS_DATEN_BEREICH_BEGINN)
	STS(adr_GPS_DATEN_SCHREIB_POSITION_L),temp1	; in SRAM schreiben	
	STS(adr_GPS_DATEN_SCHREIB_POSITION_H),temp2	; in SRAM schreiben	
; AKTIVIERUNG Datenempfang				
	ldi temp, 1
	STS(adr_AKTIVIERUNG_GPS_EMPFANG),temp		; in SRAM schreiben	
; Deaktivierung DATEN-AUFBEREITUNG		
	clr temp
	STS(adr_AKTIVIERUNG_GPS_AUFBEREITUNG),temp		; in SRAM schreiben	

 
ret
;#######################################################################
;#######################################################################
;#######################################################################
; Interruptroutine: wird ausgefhrt sobald ein Byte ber das UART empfangen wurde
ZEICHEN_EINLESEN:
		
		push temp           ; temp auf dem Stack sichern            
		in TEMP,SREG		; Einlesen des SREG 
		push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
		push R0
		push R1
		push R2
		push R3
		push R4
		push R5
		push R6
		push R7
		push R8
		push R9
		push R10
		push R11
		push R12
		push R13
		push R14
		push R15
		push temp1
		push temp2
		push temp3
		push temp4
		push temp5
		push temp6
		push temp7
		push temp8
		push temp9
		push XL
		push XH
		push YL
		push YH
		push ZL
		push ZH

;-------
		
		in GPS_EMPFANGSZEICHEN, UDR	
		rcall ZEICHEN_AUFBEREITEN	; INPUT: GPS_EMPFANGSZEICHEN	
		rcall GPS_DATEN_AUFBEREITEN
		rcall GPS_BERECHNUNG_ENTFERNUNG
;-------
		pop ZH
		pop ZL
		pop YH
		pop YL
		pop XH
		pop XL
		pop temp9
		pop temp8
		pop temp7
		pop temp6
		pop temp5
		pop temp4
		pop temp3
		pop temp2
		pop temp1
		pop R15
		pop R14
		pop R13
		pop R12		
		pop R11		
		pop R10		
		pop R9		
		pop R8		
		pop R7		
		pop R6
		pop R5
		pop R4
		pop R3
		pop R2
		pop R1
		pop R0		
		pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
		out	SREG,TEMP		; Wiederherstellen von SREG       
		pop temp      		; temp wiederherstellen                    
reti                              
;############################################################################
;############################################################################
;############################################################################
;																			 
; $GPGGA,105836,5059.2543,N,01101.2294,E,0,00,0.0,248.0,M,248.0,M,0.0,0000*51
; $GPGSA,A,1,06,02,06,06,06,02,06,06,02,06,06,06,0.0,0.0,0.0*34				 
; $GPGSV,3,1,12,06,48,032,00,02,20,309,00,06,48,032,00,06,48,032,00*79		 
; $GPGSV,3,2,12,06,48,032,00,02,20,309,00,06,48,032,00,06,48,032,00*7A		 
; $GPGSV,3,3,12,02,20,309,00,06,48,032,00,06,48,032,00,06,48,032,00*7B		 
; $GPRMC,105836,V,5059.2543,N,01101.2294,E,0.00,0.00,100506,0.0,W*7D		 
;																			 
;																			 
; INPUT: GPS_EMPFANGSZEICHEN												 
;																			 
ZEICHEN_AUFBEREITEN:
; ist GPS-EMPFANG aktiv ?	
	LDS temp, (adr_AKTIVIERUNG_GPS_EMPFANG)	; aus SRAM laden	
	tst temp
	brne ZEICHEN_AUFBEREITEN_SCHREIBPOSITION
	ret
ZEICHEN_AUFBEREITEN_SCHREIBPOSITION:
; SCHREIBPOSITION => ist das ENDE des SRAM-GPS-SPEICHER-Bereichs erreicht	?
	; aktuelle SCHREIBPOSITION laden
	LDS XL,(adr_GPS_DATEN_SCHREIB_POSITION_L)			; aus SRAM laden	
	LDS XH,(adr_GPS_DATEN_SCHREIB_POSITION_H)			; aus SRAM laden	
	; vergleichen	
	cpi XH,high(adr_GPS_DATEN_BEREICH_ENDE)
	brlo ZEICHEN_AUFBEREITEN_SCHREIBPOSITION_GUELTIG	; kleiner => gltig			
	breq ZEICHEN_AUFBEREITEN_SCHREIBPOSITION_w			; gleich  => PRFUNG high	
	brsh ZEICHEN_AUFBEREITEN_SCHREIBPOSITION_FEHLER		; groesser=> FEHLER		 	
ZEICHEN_AUFBEREITEN_SCHREIBPOSITION_w:
	cpi XL, low(adr_GPS_DATEN_BEREICH_ENDE)
	brlo ZEICHEN_AUFBEREITEN_SCHREIBPOSITION_GUELTIG	; kleiner => gltig			
	breq ZEICHEN_AUFBEREITEN_SCHREIBPOSITION_GUELTIG	; gleich  => gltig			

ZEICHEN_AUFBEREITEN_SCHREIBPOSITION_FEHLER:
	rjmp ZEICHEN_AUFBEREITEN_FEHLER
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
ZEICHEN_AUFBEREITEN_SCHREIBPOSITION_GUELTIG:



; ANZAHL ZEICHEN auslesen				
	LDS XL,(adr_GPS_DATEN_ZEICHEN_ANZAHL_L)				; aus SRAM laden	
	LDS XH,(adr_GPS_DATEN_ZEICHEN_ANZAHL_H)				; aus SRAM laden	
	adiw XL,1											; +1				
; ANZAHL ZEICHEN neu schreiben			
	STS (adr_GPS_DATEN_ZEICHEN_ANZAHL_L),XL				; in SRAM speichern	
	STS (adr_GPS_DATEN_ZEICHEN_ANZAHL_H),XH				; in SRAM speichern	

; PRFUNG der GPS-EMPFANGSZEICHEN:  "$GPGGA, ..."
; PRFUNG 1. ZEICHEN "$"				
	cpi XH,high(1)
	brne ZEICHEN_AUFBEREITEN_1_ZEICHEN_FERTIG
	cpi XL, low(1)
	brne ZEICHEN_AUFBEREITEN_1_ZEICHEN_FERTIG
	ldi temp, '$'
	cp GPS_EMPFANGSZEICHEN, temp						; vergleich ?					
	breq ZEICHEN_AUFBEREITEN_1_ZEICHEN_FERTIG			; ja							
	rjmp ZEICHEN_AUFBEREITEN_FEHLER						; nein => FEHLER			  	
ZEICHEN_AUFBEREITEN_1_ZEICHEN_FERTIG:

; PRFUNG 5. ZEICHEN "G"				
	cpi XH,high(5)
	brne ZEICHEN_AUFBEREITEN_5_ZEICHEN_FERTIG
	cpi XL, low(5)
	brne ZEICHEN_AUFBEREITEN_5_ZEICHEN_FERTIG
	ldi temp, 'G'
	cp GPS_EMPFANGSZEICHEN, temp						; vergleich ?					
	breq ZEICHEN_AUFBEREITEN_5_ZEICHEN_FERTIG			; ja							
	rjmp ZEICHEN_AUFBEREITEN_FEHLER						; nein => FEHLER			  	
ZEICHEN_AUFBEREITEN_5_ZEICHEN_FERTIG:
; PRFUNG 6. ZEICHEN "A"				
	cpi XH,high(6)
	brne ZEICHEN_AUFBEREITEN_6_ZEICHEN_FERTIG
	cpi XL, low(6)
	brne ZEICHEN_AUFBEREITEN_6_ZEICHEN_FERTIG
	ldi temp, 'A'
	cp GPS_EMPFANGSZEICHEN, temp						; vergleich ?					
	breq ZEICHEN_AUFBEREITEN_6_ZEICHEN_FERTIG			; ja							
	; FEHLERCODE				
	ldi temp, 20
	STS (adr_FEHLER_CODE),temp							; in SRAM speichern
	rjmp ZEICHEN_AUFBEREITEN_FEHLER						; nein => FEHLER			  	
ZEICHEN_AUFBEREITEN_6_ZEICHEN_FERTIG:



ZEICHEN_AUFBEREITEN_7_ZEICHEN_FERTIG:

; ANZAHL der DATENSTZE zhlen (6Stk) (1 Datensatz wird durch chr(13) abgeschlossen
	ldi temp, 13	
	cp GPS_EMPFANGSZEICHEN, temp						; vergleich ?					
	brne ZEICHEN_AUFBEREITEN_ANZAHL_DATENSAETZE_FERTIG
	; ANZAHL laden					
	LDS temp,(adr_GPS_DATEN_DATENSATZ_ANZAHL)			; aus SRAM laden	
	inc temp											; +1
	; Vergleich						
	cpi temp,6											; vergleich ?
	brlo ZEICHEN_AUFBEREITEN_ANZAHL_DATENSAETZE_w		; kleiner	
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
; DATENEMPFANG STOPPEN														
	clr temp
	STS(adr_AKTIVIERUNG_GPS_EMPFANG),temp				; in SRAM schreiben	
; Aktivierung DATEN-AUFBEREITUNG		
	ldi temp,1
	STS(adr_AKTIVIERUNG_GPS_AUFBEREITUNG),temp			; in SRAM schreiben	

ZEICHEN_AUFBEREITEN_ANZAHL_DATENSAETZE_w:
	; ANZAHL DATENSATZ laden		
	LDS temp,(adr_GPS_DATEN_DATENSATZ_ANZAHL)			; aus SRAM laden	
	inc temp
	; ANZAHL DATENSATZ SPEICHERN	
	STS(adr_GPS_DATEN_DATENSATZ_ANZAHL),temp			; in SRAM speichern	
;---------------------------------------------------------------------------
; GPS-EMPFANGS-ZEICHEN an neuer SCHREIBPOSITION schreiben	
ZEICHEN_AUFBEREITEN_ANZAHL_DATENSAETZE_FERTIG:
	LDS XL,(adr_GPS_DATEN_SCHREIB_POSITION_L)			; aus SRAM laden	
	LDS XH,(adr_GPS_DATEN_SCHREIB_POSITION_H)			; aus SRAM laden	
	ST X+, GPS_EMPFANGSZEICHEN							; schreiben und x+1	
; neue SCHREIBPOSITION schreiben							
	STS (adr_GPS_DATEN_SCHREIB_POSITION_L),XL			; in SRAM speichern	
	STS (adr_GPS_DATEN_SCHREIB_POSITION_H),XH			; in SRAM speichern	
	ret
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
ZEICHEN_AUFBEREITEN_FEHLER:
	rcall GPS_CLEAR_START
ret
;############################################################################
;############################################################################
;############################################################################
;	1		2		3	  4		 5	   6 7	8  9	10  11	12 13  14  15					 
; $GPGGA,105836,5059.2543,N,01101.2294,E,0,00,0.0,248.0,M,248.0,M,0.0,0000*51
; $GPGSA,A,1,06,02,06,06,06,02,06,06,02,06,06,06,0.0,0.0,0.0*34				 
; $GPGSV,3,1,12,06,48,032,00,02,20,309,00,06,48,032,00,06,48,032,00*79		 
; $GPGSV,3,2,12,06,48,032,00,02,20,309,00,06,48,032,00,06,48,032,00*7A		 
; $GPGSV,3,3,12,02,20,309,00,06,48,032,00,06,48,032,00,06,48,032,00*7B		 
;  99      100 101   102   103    104   105 106  107  108   109					 
; $GPRMC,105836,V,5059.2543,N,01101.2294,E,0.00,0.00,100506,0.0,W*7D		 
;																			 
; HHE negativ																 
;$GPGGA,194621,5059.2547,N,01101.1100,E,0,04,11.1,-71.4,M,-71.4,M,0.0,0000*6D
;$GPGSA,A,1,26,29,09,28,17,18,08,22,05,,,,40.0,11.1,1.0*3A						
;$GPGSV,3,1,09,26,66,170,42,29,58,164,42,09,44,269,00,28,35,055,41*78			
;$GPGSV,3,2,09,17,34,106,39,18,25,286,00,08,08,087,00,22,08,321,00*78			
;$GPGSV,3,3,09,05,07,225,00,,,,,,,,,,,,*47										
;$GPRMC,194621,V,5059.2547,N,01101.1100,E,0.00,0.00,100506,0.0,W*74				

GPS_DATEN_AUFBEREITEN:
	; wurde der GPS-STRING komplett eingelesen ?
	LDS temp,(adr_AKTIVIERUNG_GPS_AUFBEREITUNG)	; aus SRAM laden
	tst temp									; <>0 ?			
	brne GPS_DATEN_AUFBEREITEN_START			; ja =>SPRUNG 	
	ret
GPS_DATEN_AUFBEREITEN_START:


;-------------------------------------------------------------------------------
; FELD-101 FEHLERPRFUNG muss "A" ODER "V" sein	
	ldi temp1,101
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	LD temp,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	cpi temp, 'A'								; gleich "A"	
	breq GPS_DATEN_AUFBEREITEN_w				; ja => SPRUNG	
	cpi temp, 'V'								; gleich "V"	
	breq GPS_DATEN_AUFBEREITEN_w				; ja => SPRUNG	
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; FEHLER im DATENSATZ															
;-------------------------------------------------------------------------------	
	; FEHLERCODE				
	ldi temp, 100
	STS (adr_FEHLER_CODE),temp							; in SRAM speichern
	; GPS_CLEAR_START			
	rcall GPS_CLEAR_START
	ret
;-------------------------------------------------------------------------------
GPS_DATEN_AUFBEREITEN_w:
	cbi PORTD, LED_D_BLAU	; BLAU an	

;-------------------------------------------------------------------------------
; FELD 2 (ZEIT)
	ldi temp1,2
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_hh),temp1						; in SRAM schreiben						
	;
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_mm),temp1						; in SRAM schreiben						
	;
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_ss),temp1						; in SRAM schreiben						
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; FELD 108 (DATUM)
	ldi temp1,108
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_TAG),temp1						; in SRAM schreiben						
	;
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_MONAT),temp1					; in SRAM schreiben						
	;
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_JAHR),temp1					; in SRAM schreiben						
;-------------------------------------------------------------------------------
; FELD 101 (GPS-AKTIV) A/V				
	ldi temp1,101
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	LD temp,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	clr temp1
	STS (adr_GPS_AKTIV),temp1					; in SRAM schreiben	
	cpi temp, 'A'								; gleich "A"		
	brne GPS_DATEN_AUFBEREITEN_AKTIV_w			; nein ==>SPRING	
	ldi temp1, 1
	STS (adr_GPS_AKTIV),temp1					; in SRAM schreiben	
GPS_DATEN_AUFBEREITEN_AKTIV_w:
;-------------------------------------------------------------------------------
; FELD 39 (ANZAHL-SATELLITEN-gesamt)	
	ldi temp1,39
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_ANZ_SAT_GESAMT),temp1

;-------------------------------------------------------------------------------
; FELD 8 (ANZAHL-SATELLITEN-empfangen)	
	ldi temp1,8
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_ANZ_SAT_EMPFANGEN),temp1
;-------------------------------------------------------------------------------
; FELD 9 (GENAUIGKEIT)
	ldi temp1,9
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	; durch 10 teilen	
	clr temp3
	clr temp4
	ldi temp5, low(10)
	ldi temp6,HIGH(10)
	clr temp7
	clr temp8
	rcall DIVISION_32_32											; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
	STS (adr_GPS_GENAUIGKEIT),temp1

;-------------------------------------------------------------------------------
; FELD 10 (HHE)							
	ldi temp1,10
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	; durch 10 teilen	
	clr temp3
	clr temp4
	ldi temp5, low(10)
	ldi temp6,HIGH(10)
	clr temp7
	clr temp8
	rcall DIVISION_32_32											; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
	; GPS-HHEN-ANGABE-SPEICHERN		
	STS(adr_GPS_HOEHE_L),temp1				; in SRAM speichern
	STS(adr_GPS_HOEHE_H),temp2				; in SRAM speichern
	; OFFSET-WERT laden	
	LDS temp3,(adr_GPS_HOEHE_OFFSET_L)
	LDS temp4,(adr_GPS_HOEHE_OFFSET_H)	
	; HHENDIFFERENZ ermitteln			
	sub temp1,temp3
	sbc temp2,temp4 
	; BERECHNETE-HHEN-ANGABE-SPEICHERN	
	STS(adr_GPS_HOEHE_BERECHNET_L),temp1	; in SRAM speichern 
	STS(adr_GPS_HOEHE_BERECHNET_H),temp2	; in SRAM speichern	


;-------------------------------------------------------------------------------
; FELD 106 (SOG_GESCHWINDIGKEIT) "12.34" kn 
	ldi temp1,106
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 	; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	;mal 1852 (1 kn = 1,852 km/h)	
	ldi temp3, low(FAKTOR_KNOTEN)
	ldi temp4,high(FAKTOR_KNOTEN)
	rcall FUNKTION_MULTIPLIKATION_16_16	; INP: TEMP1...2 / TEMP3...4 OUT: TEMP1...4 	
	; durch 100.000				 	
	ldi temp5,BYTE1(100000)
	ldi temp6,BYTE2(100000)
	ldi temp7,BYTE3(100000)
	clr temp8
	rcall DIVISION_32_32				; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
	STS(adr_GPS_GESCHWINDIGKEIT_L),temp1
	STS(adr_GPS_GESCHWINDIGKEIT_H),temp2
;-------------------------------------------------------------------------------
; FELD 107 (KURS)
	ldi temp1,107
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 	; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	; durch 100 teilen	
	clr temp3
	clr temp4
	ldi temp5, low(100)
	ldi temp6,HIGH(100)
	clr temp7
	clr temp8
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
	STS(adr_GPS_KURS_L),temp1
	STS(adr_GPS_KURS_H),temp2
;-------------------------------------------------------------------------------
; FELD 3 (Y==>NRDLICHE-BREITE)	$GPGGA,105836,5059.2543,
	; WERT lschen	
	clr temp
	STS (adr_GPS_Y_BREITE_BYTE1),temp	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE2),temp	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE3),temp	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE4),temp	; in SRAM speichern	
	; X-ZEIGER-INITIALISIEREN auf GRAD-WERT	
	ldi XL, low(adr_GPS_DATEN_BEREICH_BEGINN+14)
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+14)
	rcall FUNKTION_HEX_ASC_CLEAR_32  	; OUT TEMP1...9 (alle auf "0")			
	; GRAD-WERT einlesen und mal 1.000.000	
	LD temp8,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp7,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	rcall FUNKTION_ASC_HEX_32 			; INP: TEMP1...9 / OUT: TEMP1...4
	STS (adr_GPS_Y_BREITE_BYTE1),temp1	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE2),temp2	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE3),temp3	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE4),temp4	; in SRAM speichern	

	; X-ZEIGER-INITIALISIEREN auf MINUTEN-WERT	
	ldi XL, low(adr_GPS_DATEN_BEREICH_BEGINN+16)
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+16)
	rcall FUNKTION_HEX_ASC_CLEAR_32  	; OUT TEMP1...9 (alle auf "0")			
	; MINUTEN-WERT einlesen und mal 100			
	LD temp8,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp7,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	adiw XL,1							; X-Zeiger erhhen					   
	LD temp6,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp5,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp4,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp3,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	rcall FUNKTION_ASC_HEX_32 			; INP: TEMP1...9 / OUT: TEMP1...4	   
	; MINUTEN-WERT durch 60						
	ldi temp5, BYTE1(60)
	ldi temp6, BYTE2(60)
	ldi temp7, BYTE3(60)
	ldi temp8, BYTE4(60)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
	; GRAD-WERT LADEN					
	LDS temp5,(adr_GPS_Y_BREITE_BYTE1)	; aus SRAM laden	
	LDS temp6,(adr_GPS_Y_BREITE_BYTE2)	; aus SRAM laden	
	LDS temp7,(adr_GPS_Y_BREITE_BYTE3)	; aus SRAM laden	
	LDS temp8,(adr_GPS_Y_BREITE_BYTE4)	; aus SRAM laden	
	; GRAD und MINUTEN WERT addieren	
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; GRAD und MINUTEN WERT als DEZIMALWERT speichern		
	STS (adr_GPS_Y_BREITE_BYTE1),temp1	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE2),temp2	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE3),temp3	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE4),temp4	; in SRAM speichern	

;-------------------------------------------------------------------------------
; FELD 5 (X==>STLICHE-LNGE)	$GPGGA,105836,5059.2543,N,01101.2294,
	; WERT lschen	
	clr temp
	STS (adr_GPS_X_LAENGE_BYTE1),temp	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE2),temp	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE3),temp	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE4),temp	; in SRAM speichern	
	; X-ZEIGER-INITIALISIEREN auf GRAD-WERT	
	ldi XL, low(adr_GPS_DATEN_BEREICH_BEGINN+27)
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+27)
	rcall FUNKTION_HEX_ASC_CLEAR_32  	; OUT TEMP1...9 (alle auf "0")			
	; GRAD-WERT einlesen und mal 1.000.000	
	LD temp8,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp7,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	rcall FUNKTION_ASC_HEX_32 			; INP: TEMP1...9 / OUT: TEMP1...4
	STS (adr_GPS_X_LAENGE_BYTE1),temp1	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE2),temp2	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE3),temp3	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE4),temp4	; in SRAM speichern	

	; X-ZEIGER-INITIALISIEREN auf MINUTEN-WERT	
	ldi XL, low(adr_GPS_DATEN_BEREICH_BEGINN+29)
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+29)
	rcall FUNKTION_HEX_ASC_CLEAR_32  	; OUT TEMP1...9 (alle auf "0")			
	; MINUTEN-WERT einlesen und mal 100			
	LD temp8,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp7,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	adiw XL,1							; X-Zeiger erhhen					   
	LD temp6,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp5,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp4,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp3,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	rcall FUNKTION_ASC_HEX_32 			; INP: TEMP1...9 / OUT: TEMP1...4	   
	; MINUTEN-WERT durch 60						
	ldi temp5, BYTE1(60)
	ldi temp6, BYTE2(60)
	ldi temp7, BYTE3(60)
	ldi temp8, BYTE4(60)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
	; GRAD-WERT LADEN					
	LDS temp5,(adr_GPS_X_LAENGE_BYTE1)	; aus SRAM laden	
	LDS temp6,(adr_GPS_X_LAENGE_BYTE2)	; aus SRAM laden	
	LDS temp7,(adr_GPS_X_LAENGE_BYTE3)	; aus SRAM laden	
	LDS temp8,(adr_GPS_X_LAENGE_BYTE4)	; aus SRAM laden	
	; GRAD und MINUTEN WERT addieren	
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; GRAD und MINUTEN WERT als DEZIMALWERT speichern		
	STS (adr_GPS_X_LAENGE_BYTE1),temp1	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE2),temp2	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE3),temp3	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE4),temp4	; in SRAM speichern	

ret
GPS_BERECHNUNG_ENTFERNUNG:
	; werden gerade DATEN empfangen?
	LDS temp,(adr_AKTIVIERUNG_GPS_EMPFANG)		; aus SRAM laden	
	tst temp									; =0 ?				
	breq GPS_BERECHNUNG_ENTFERNUNG_START		; ja ==SPRUNG		
	ret	
GPS_BERECHNUNG_ENTFERNUNG_START:

	; Maeinheit auf m (Meter) umschalten	
	clr temp
	STS(adr_GPS_ENTFERNUNG_in_km),temp			; 0=Meter 1=km		
	; GPS-LNGE LADEN					
	LDS temp1,(adr_GPS_X_LAENGE_BYTE1)			; aus SRAM laden	
	LDS temp2,(adr_GPS_X_LAENGE_BYTE2)			; aus SRAM laden	
	LDS temp3,(adr_GPS_X_LAENGE_BYTE3)			; aus SRAM laden	
	LDS temp4,(adr_GPS_X_LAENGE_BYTE4)			; aus SRAM laden	
	; REFERENZ_LNGE laden				
	LDS temp5,(adr_GPS_REFERENZ_X_LAENGE_BYTE1)	; aus SRAM laden	
	LDS temp6,(adr_GPS_REFERENZ_X_LAENGE_BYTE2)	; aus SRAM laden	
	LDS temp7,(adr_GPS_REFERENZ_X_LAENGE_BYTE3)	; aus SRAM laden	
	LDS temp8,(adr_GPS_REFERENZ_X_LAENGE_BYTE4)	; aus SRAM laden	
	; DIFFERENZ berechnen	(Bsp: 11.020.923-10.816.423=204.500)
	sub temp1,temp5
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8
	; BETRAG BILDEN	
	rcall FUNKTION_BETRAG_BILDEN_32 	; INP:TEMP1...4 OUT: TEMP1...4 
	;durch 10 (Bsp: 204.500 / 10 = 20.450)
	rcall FUNKTION_DIVISION_DURCH_10_32 ; INP:TEMP1...4 OUT: TEMP1...4 

	; ist ERGEBNIS > 65.535 (2Byte-WERT) temp3 und temp4 muss 0 sein
	tst temp3
	brne GPS_BERECHNUNG_ENTFERNUNG_X_auf_km
	tst temp4
	brne GPS_BERECHNUNG_ENTFERNUNG_X_auf_km
	rjmp GPS_BERECHNUNG_ENTFERNUNG_X_METER
	; Maeinheit auf km  umschalten		
GPS_BERECHNUNG_ENTFERNUNG_X_auf_km:
	ldi temp,1
	STS(adr_GPS_ENTFERNUNG_in_km),temp	; 0=Meter 1=km		
	;durch 1000					(Bsp: 1.435.000 / 100 = 14.350)
	rcall FUNKTION_DIVISION_DURCH_1000_32 ; INP: TEMP1...4 OUT: TEMP1...4 

	; mal FAKTOR-X (70km/GRD)	(Bsp: 20.450*70=1.435.000)
GPS_BERECHNUNG_ENTFERNUNG_X_METER:
	ldi temp3, LOW(FAKTOR_X)
	ldi temp4,HIGH(FAKTOR_X)
	rcall FUNKTION_MULTIPLIKATION_16_16	; INPUT: TEMP1+2/TEMP3+4 OUTPUT: Temp1...4	
	;durch 100					(Bsp: 1.435.000 / 100 = 14.350)
	rcall FUNKTION_DIVISION_DURCH_100_32 ; INP: TEMP1...4 OUT: TEMP1...4 
	; DIFFERENZ speichern	  
	STS(adr_X_LAENGE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	


;-------------------------------------------------------------------
	; GPS-BREITE LADEN					
	LDS temp1,(adr_GPS_Y_BREITE_BYTE1)			; aus SRAM laden	
	LDS temp2,(adr_GPS_Y_BREITE_BYTE2)			; aus SRAM laden	
	LDS temp3,(adr_GPS_Y_BREITE_BYTE3)			; aus SRAM laden	
	LDS temp4,(adr_GPS_Y_BREITE_BYTE4)			; aus SRAM laden	
	; REFERENZ-BREITE laden				
	LDS temp5,(adr_GPS_REFERENZ_Y_BREITE_BYTE1)	; aus SRAM laden	
	LDS temp6,(adr_GPS_REFERENZ_Y_BREITE_BYTE2)	; aus SRAM laden	
	LDS temp7,(adr_GPS_REFERENZ_Y_BREITE_BYTE3)	; aus SRAM laden	
	LDS temp8,(adr_GPS_REFERENZ_Y_BREITE_BYTE4)	; aus SRAM laden	
	; DIFFERENZ berechnen	(Bsp: 50987526-50869762=117.764)
	sub temp1,temp5
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8
	; BETRAG BILDEN					
	rcall FUNKTION_BETRAG_BILDEN_32 	; INP:TEMP1...4 OUT: TEMP1...4 
	;durch 10 (Bsp: 117.764 / 10= 11.776)
	rcall FUNKTION_DIVISION_DURCH_10_32 ; INP:TEMP1...4 OUT: TEMP1...4 

	; wurde schon auf km umgeschaltet
	LDS temp,(adr_GPS_ENTFERNUNG_in_km)	; aus SRAM laden			
	tst temp							; 0=Meter 1=km		
	breq GPS_BERECHNUNG_ENTFERNUNG_Y_ww
	; PROGRAMM-CODE??????????


	; ist ERGEBNIS > 65.535 (2Byte-WERT) temp3 und temp4 muss 0 sein
GPS_BERECHNUNG_ENTFERNUNG_Y_ww:
	tst temp3
	brne GPS_BERECHNUNG_ENTFERNUNG_Y_auf_km
	tst temp4
	brne GPS_BERECHNUNG_ENTFERNUNG_Y_auf_km
	rjmp GPS_BERECHNUNG_ENTFERNUNG_Y_METER 
	; Maeinheit auf km umschalten	
GPS_BERECHNUNG_ENTFERNUNG_Y_auf_km:
	; Y_BREITE durch 1000				
	rcall FUNKTION_DIVISION_DURCH_1000_32 ; INP: TEMP1...4 OUT: TEMP1...4 
	; WURDE X schon auf km berechnet ?
	LDS temp, (adr_GPS_ENTFERNUNG_in_km)
	tst temp
	brne GPS_BERECHNUNG_ENTFERNUNG_Y_METER	
	; X wurde noch nicht auf km umgerechnet
	ldi temp,1
	STS(adr_GPS_ENTFERNUNG_in_km),temp
	push temp1	; Sicherungskopie auf STACK	
	push temp2
	push temp3
	push temp4
	; X-BREITE laden			
	LDS temp1,(adr_X_LAENGE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_X_LAENGE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	LDS temp3,(adr_X_LAENGE_DIFFERENZ_BYTE3)	; aus SRAM laden	
	LDS temp4,(adr_X_LAENGE_DIFFERENZ_BYTE4)	; aus SRAM laden	
	;durch 1000					
	rcall FUNKTION_DIVISION_DURCH_1000_32 ; INP: TEMP1...4 OUT: TEMP1...4 
	; X-BREITE speichern		
	STS(adr_X_LAENGE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	
	pop  temp4	; sicherungskopie laden		
	pop  temp3
	pop  temp2
	pop  temp1
	; mal FAKTOR-Y (111km/GRD)	(Bsp:11.776*111=1.307.136 )
GPS_BERECHNUNG_ENTFERNUNG_Y_METER:
	ldi temp3, LOW(FAKTOR_Y)
	ldi temp4,HIGH(FAKTOR_Y)
	rcall FUNKTION_MULTIPLIKATION_16_16	; INPUT: TEMP1+2/TEMP3+4 OUTPUT: Temp1...4	
	;durch 100					(Bsp:1.307.136 / 100= 13.071)
	rcall FUNKTION_DIVISION_DURCH_100_32 ; INP: TEMP1...4 OUT: TEMP1...4 
	; DIFFERENZ speichern	  
	STS(adr_Y_BREITE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	

; #################################################################
	; Y - BREITE Quadrieren	
	mov temp3,temp1
	mov temp4,temp2
	rcall FUNKTION_MULTIPLIKATION_16_16	; INPUT: TEMP1+2/TEMP3+4 OUTPUT: Temp1...4	
	; Y - BREITE Zwischenergebnis speichern
	STS(adr_GPS_ENTFERNUNG_BYTE_1),temp1		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_2),temp2		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_3),temp3		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_4),temp4		; in SRAM speichern	
	; X - LNGE Quadrieren					
	LDS temp1,(adr_X_LAENGE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_X_LAENGE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	mov temp3,temp1
	mov temp4,temp2
	rcall FUNKTION_MULTIPLIKATION_16_16			; INPUT: TEMP1+2/TEMP3+4 OUTPUT: Temp1...4		
	; Y - BREITE Zwischenergebnis laden		
	LDS temp5,(adr_GPS_ENTFERNUNG_BYTE_1)		; aus SRAM laden	
	LDS temp6,(adr_GPS_ENTFERNUNG_BYTE_2)		; aus SRAM laden	
	LDS temp7,(adr_GPS_ENTFERNUNG_BYTE_3)		; aus SRAM laden	
	LDS temp8,(adr_GPS_ENTFERNUNG_BYTE_4)		; aus SRAM laden	
	;     X und Y    addieren				
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; WURZEL ziehen							
	rcall WURZEL_32								; INP: TEMP1...4 OUT: TEMP1...2
	clr temp3
	clr temp4
	; ENTFERNUNG speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_1),temp1		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_2),temp2		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_3),temp3		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_4),temp4		; in SRAM speichern	

	rcall GPS_CLEAR_START

	sbi PORTD, LED_D_BLAU	; BLAU aus	

ret
;###################################################################
;###################################################################
;###################################################################






;###################################################################
;###################################################################
;###################################################################
; TIMER	0,1s														
TIM1_OVF:      
; Sichern				
		push temp           ; temp auf dem Stack sichern            
		in TEMP,SREG		; Einlesen des SREG 
		push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
		push temp1

;----------------------
; Timer Startwert	 
	ldi temp,HIGH(TIMERWERT)	;HIGH
	out tcnt1H,temp         
	ldi temp,LOW(TIMERWERT)   	;LOW   
	out tcnt1L,temp

;----------------------
	rcall ZEIT

;----------------------
;Zurckschreiben		
		pop temp1
		pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
		out	SREG,TEMP		; Wiederherstellen von SREG       
		pop temp      		; temp wiederherstellen                    
reti                  
;#######################################################################
;#######################################################################
;#######################################################################
ZEIT:
	LDS temp,(adr_SYSTEM_ss10)	; aus SRAM_LADEN		
	cpi temp,0					; vergleich	
	breq ZEIT_w
	cpi temp,5					; vergleich	
	breq ZEIT_w
	rjmp ZEIT_ss10
ZEIT_w:
	ldi temp,1
	STS (adr_AKTIVIERUNG_ANZEIGE),temp	; in SRAM speichern	
; 10-tel SEKUNDE	
ZEIT_ss10:
	LDS temp,(adr_SYSTEM_ss10)	; aus SRAM_LADEN		
	inc temp					; +1	
	cpi temp,10
	brsh ZEIT_SS
	STS (adr_SYSTEM_ss10),temp	; in SRAM schreiben		
	ret
; SEKUNDE			
ZEIT_SS:
	clr temp
	STS (adr_SYSTEM_ss10),temp	; in SRAM schreiben		

	LDS temp,(adr_BETRIEBSSTUNDEN_SS)	; aus SRAM_LADEN		
	inc temp					; +1 
	cpi temp,60
	brsh ZEIT_MM
	STS (adr_BETRIEBSSTUNDEN_ss),temp	; in SRAM schreiben		
	ret
; MINUTE			
ZEIT_MM:
	clr temp
	STS (adr_BETRIEBSSTUNDEN_ss),temp			; in SRAM schreiben		
;------------------
	LDS temp,(adr_BETRIEBSSTUNDEN_SPEICHERN)	; aus SRAM_LADEN		
	inc temp	;+1
	STS(adr_BETRIEBSSTUNDEN_SPEICHERN),temp
;------------------
	LDS temp,(adr_BETRIEBSSTUNDEN_mm)	; aus SRAM_LADEN		
	inc temp					; +1 
	cpi temp,60
	brsh ZEIT_HH
	STS (adr_BETRIEBSSTUNDEN_mm),temp	; in SRAM schreiben		
	ret
; STUNDE			
ZEIT_HH:
	clr temp
	STS (adr_BETRIEBSSTUNDEN_mm),temp	; in SRAM schreiben		
	LDS temp,(adr_BETRIEBSSTUNDEN_hh)	; aus SRAM_LADEN		
	inc temp					; +1 
	STS (adr_BETRIEBSSTUNDEN_hh),temp	; in SRAM schreiben		
ret
;#######################################################################
;#######################################################################
;#######################################################################